﻿namespace Pfr.Services.Scheduler
{
    public class Scheduler
    {
        private long _Interval = 1000;
        private Timer _timer;
        private TimerCallback _timerCallback;
        private TimeExec _TimeExec;
        private DateTime _DateTimeExec;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="pTimeExec"></param>
        public Scheduler(TimeExec pTimeExec)
        {
            _timerCallback = new TimerCallback(CheckTime);
            _timer = new Timer(_timerCallback, null, 0, _Interval);

            _TimeExec = pTimeExec;
            if(DateTime.Now.Hour <= pTimeExec.Hour)
            {
                if(DateTime.Now.Minute < pTimeExec.Minute)
                {
                    //Todo-OK устанавливаем время запуска сегодня
                    _DateTimeExec = new DateTime(DateTime.Now.Year,
                                                    DateTime.Now.Month,
                                                    DateTime.Now.Day,
                                                    pTimeExec.Hour,
                                                    pTimeExec.Minute,
                                                    pTimeExec.Second);
                }
                else
                {
                    //Todo-OK устанавливаем время запуска завтра
                    _DateTimeExec = new DateTime(DateTime.Now.Year,
                                                    DateTime.Now.Month,
                                                    DateTime.Now.Day,
                                                    pTimeExec.Hour,
                                                    pTimeExec.Minute,
                                                    pTimeExec.Second);
                    _DateTimeExec = _DateTimeExec.AddDays(1);
                }
            }
            else
            {
                //Todo-OK устанавливаем время запуска завтра
                _DateTimeExec = new DateTime(DateTime.Now.Year,
                                                DateTime.Now.Month,
                                                DateTime.Now.Day,
                                                pTimeExec.Hour,
                                                pTimeExec.Minute,
                                                pTimeExec.Second);
                _DateTimeExec = _DateTimeExec.AddDays(1);
            }
        }

        public delegate void CheckTimeHandler(DateTime pDateTimeExec);
        //public delegate void CheckTimeHandler();

        public event CheckTimeHandler? OnExecute;
        private void CheckTime(object obj)
        {
            if (Run())
            {
                OnExecute?.Invoke(_DateTimeExec);
                _DateTimeExec = _DateTimeExec.AddHours(24);
            }
        }

        private bool Run()
        {
            bool _Exec = false;
            DateTime _curDateTime = DateTime.Now;
            _Exec = false;
            if ((_curDateTime.Day == _DateTimeExec.Day)
                &&(_curDateTime.Hour == _DateTimeExec.Hour)
                && (_curDateTime.Minute == _DateTimeExec.Minute))
            {
                _Exec = true;
            }
            return _Exec;
        }

    }
}