﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pfr.Services.Scheduler
{
    public class TimeExec
    {
        private readonly int DefaultHour = 0;
        private readonly int DefaultMinute = 0;
        private readonly int DefaultSecond = 0;
        

        private int _Hour;
        private int _Minute;
        private int _Second;
        public TimeExec()
        {
            _Hour = DefaultHour;
            _Minute = DefaultMinute;
            _Second = DefaultSecond;
        }


        /// <summary>
        /// Конструктор время выполнения
        /// </summary>
        /// <param name="hour"> час от 0 до 23</param>
        /// <param name="minute">мин от 0 до 59</param>
        /// <exception cref="ArgumentException"></exception>
        public TimeExec(int hour, int minute)
        {
            InitProp(hour, minute);
            Second = DefaultSecond;
        }

        public TimeExec(int hour, int minute, int second)
        {
            InitProp(hour, minute);
            if ((second > 59) || (second < 0))
            {
                throw new ArgumentException(string.Format("second value from 0 to 59 this value {0}", second));
            }
            Second = second;
        }
        private void InitProp(int hour, int minute)
        {
            if ((hour > 23) || (hour < 0))
            {
                throw new ArgumentException(string.Format("hour value from 0 to 23 this value {0}", hour));
            }
            if ((minute > 59) || (minute < 0))
            {
                throw new ArgumentException(string.Format("minute value from 0 to 59 this value {0}", minute));
            }
            Hour = hour;
            Minute = minute;
        }

        /// <summary>
        /// мин от 0 до 59
        /// </summary>
        public int Minute { get => _Minute; set => _Minute = value; }

        /// <summary>
        /// час от 0 до 23
        /// </summary>
        public int Hour { get => _Hour; set => _Hour = value; }
        public int Second { get => _Second; set => _Second = value; }
    }
}
